Index: Dev/trunk/src/client/qed-client/css/icons.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/icons.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/icons.less	(revision 529)
@@ -1,168 +1,169 @@
 #rft {
-	&.claro {
-		.rftIcon {
-			.noOffset;
-			float: left;
-			display: inline-block;
-			border: none;
-			background-color: transparent;
-			background-repeat: no-repeat;
-		}
-	}
+    &.claro {
+        
+    .rftIcon {
+            .noOffset;
+            float: left;
+            display: inline-block;
+            border: none;
+            background-color: transparent;
+            background-repeat: no-repeat;
+        }
+    }
 
-	.rftIconApplication {
-		background-position: 0px 0px;
-	}
-	.rftIconDashboard {
-		background-position: -32px 0px;
-	}
-	.rftIconSession {
-		background-position: -64px 0px;
-	}
-	.rftIconSessionActive {
-		background-position: -96px 0px;
-	}
-	.rftIconSessionTemplate {
-		background-position: -128px 0px;
-	}
-	.rftIconSurvey {
-		background-position: -160px 0px;
-	}
-	.rftIconQuestion {
-		background-position: -192px 0px;
-	}
-	.rftIconQuestionFill {
-		background-position: -224px 0px;
-	}
-	.rftIconRespondent {
-		background-position: -256px 0px;
-	}
-	.rftIconAnswer {
-		background-position: -288px 0px;
-	}
-	.rftIconAnswerSet {
-		background-position: -320px 0px;
-	}
-	.rftIconGameData {
-		background-position: -352px 0px;
-	}
-	.rftIconUser {
-		background-position: -384px 0px;
-	}
-		//Actions
-	.rftIconAccept {
-		background-position: -416px 0px;
-	}
-	.rftIconCancel {
-		background-position: -448px 0px;
-	}
-	.rftIconPlus {
-		background-position: -480px 0px;
-	}
-	.rftIconMinus {
-		background-position: -512px 0px;
-	}
-	.rftIconIncrease {
-		background-position: -544px 0px;
-	}
-	.rftIconDecrease {
-		background-position: -576px 0px;
-	}
-	.rftIconDelete {
-		background-position: -608px 0px;
-	}
-	.rftIconHome {
-		background-position: -640px 0px;
-	}
-	.rftIconPreview {
-		background-position: -672px 0px;
-	}
-	.rftIconSave {
-		background-position: -704px 0px;
-	}
-	.rftIconDiscard {
-		background-position: -736px 0px;
-	}
-	.rftIconProperties {
-		background-position: -768px 0px;
-	}
-	.rftIconUndo {
-		background-position: -800px 0px;
-	}
-	.rftIconRedo {
-		background-position: -832px 0px;
-	}
-	.rftIconBack {
-		background-position: -864px 0px;
-	}
-	.rftIconForward {
-		background-position: -896px 0px;
-	}
-	.rftIconRefresh {
-		background-position: -928px 0px;
-	}
-	.rftIconHelp {
-		background-position: -960px 0px;
-	}
-	.rftIconInspect {
-		background-position: -992px 0px;
-	}
-	.rftIconTag {
-		background-position: -1024px 0px;
-	}
-	.rftIconImage {
-		background-position: -1056px 0px;
-	}
-	.rftIconEdit {
-		background-position: -1088px 0px;
-	}
-	.rftIconLock {
-		background-position: -1120px 0px;
-	}
-	.rftIconUnlock {
-		background-position: -1152px 0px;
-	}
-	.rftIconPreset {
-		background-position: -1184px 0px;
-	}
-	.rftIconTextBlock {
-		background-position: -1216px 0px;
-	}
-	.rftIconPageBreak {
-		background-position: -1248px 0px;
-	}
-	.rftIconExternal {
-		background-position: -1280px 0px;
-	}
-	.rftIconInput {
-		background-position: -1312px 0px;
-	}
-	.rftIconPublish {
-		background-position: -1344px 0px;
-	}
-	//Arrows
-	.rftIconFullArrowUp {
-		background-position: -1696px 0px;
-	}
-	.rftIconFullArrowDown {
-		background-position: -1728px 0px;
-	}
-	.rftIconFullArrowLeft {
-		background-position: -1760px 0px;
-	}
-	.rftIconFullArrowRight {
-		background-position: -1792px 0px;
-	}
-	.rftIconHalfArrowUp {
-		background-position: -1824px 0px;
-	}
-	.rftIconHalfArrowDown {
-		background-position: -1856px 0px;
-	}
-	.rftIconHalfArrowLeft {
-		background-position: -1888px 0px;
-	}
-	.rftIconHalfArrowRight {
-		background-position: -1920px 0px;
-	}
+    .rftIconApplication {
+        background-position: 0px 0px;
+    }
+    .rftIconDashboard {
+        background-position: -32px 0px;
+    }
+    .rftIconSession {
+        background-position: -64px 0px;
+    }
+    .rftIconSessionActive {
+        background-position: -96px 0px;
+    }
+    .rftIconSessionTemplate {
+        background-position: -128px 0px;
+    }
+    .rftIconSurvey {
+        background-position: -160px 0px;
+    }
+    .rftIconQuestion {
+        background-position: -192px 0px;
+    }
+    .rftIconQuestionFill {
+        background-position: -224px 0px;
+    }
+    .rftIconRespondent {
+        background-position: -256px 0px;
+    }
+    .rftIconAnswer {
+        background-position: -288px 0px;
+    }
+    .rftIconAnswerSet {
+        background-position: -320px 0px;
+    }
+    .rftIconGameData {
+        background-position: -352px 0px;
+    }
+    .rftIconUser {
+        background-position: -384px 0px;
+    }
+        //Actions
+    .rftIconAccept {
+        background-position: -416px 0px;
+    }
+    .rftIconCancel {
+        background-position: -448px 0px;
+    }
+    .rftIconPlus {
+        background-position: -480px 0px;
+    }
+    .rftIconMinus {
+        background-position: -512px 0px;
+    }
+    .rftIconIncrease {
+        background-position: -544px 0px;
+    }
+    .rftIconDecrease {
+        background-position: -576px 0px;
+    }
+    .rftIconDelete {
+        background-position: -608px 0px;
+    }
+    .rftIconHome {
+        background-position: -640px 0px;
+    }
+    .rftIconPreview {
+        background-position: -672px 0px;
+    }
+    .rftIconSave {
+        background-position: -704px 0px;
+    }
+    .rftIconDiscard {
+        background-position: -736px 0px;
+    }
+    .rftIconProperties {
+        background-position: -768px 0px;
+    }
+    .rftIconUndo {
+        background-position: -800px 0px;
+    }
+    .rftIconRedo {
+        background-position: -832px 0px;
+    }
+    .rftIconBack {
+        background-position: -864px 0px;
+    }
+    .rftIconForward {
+        background-position: -896px 0px;
+    }
+    .rftIconRefresh {
+        background-position: -928px 0px;
+    }
+    .rftIconHelp {
+        background-position: -960px 0px;
+    }
+    .rftIconInspect {
+        background-position: -992px 0px;
+    }
+    .rftIconTag {
+        background-position: -1024px 0px;
+    }
+    .rftIconImage {
+        background-position: -1056px 0px;
+    }
+    .rftIconEdit {
+        background-position: -1088px 0px;
+    }
+    .rftIconLock {
+        background-position: -1120px 0px;
+    }
+    .rftIconUnlock {
+        background-position: -1152px 0px;
+    }
+    .rftIconPreset {
+        background-position: -1184px 0px;
+    }
+    .rftIconTextBlock {
+        background-position: -1216px 0px;
+    }
+    .rftIconPageBreak {
+        background-position: -1248px 0px;
+    }
+    .rftIconExternal {
+        background-position: -1280px 0px;
+    }
+    .rftIconInput {
+        background-position: -1312px 0px;
+    }
+    .rftIconPublish {
+        background-position: -1344px 0px;
+    }
+    //Arrows
+    .rftIconFullArrowUp {
+        background-position: -1696px 0px;
+    }
+    .rftIconFullArrowDown {
+        background-position: -1728px 0px;
+    }
+    .rftIconFullArrowLeft {
+        background-position: -1760px 0px;
+    }
+    .rftIconFullArrowRight {
+        background-position: -1792px 0px;
+    }
+    .rftIconHalfArrowUp {
+        background-position: -1824px 0px;
+    }
+    .rftIconHalfArrowDown {
+        background-position: -1856px 0px;
+    }
+    .rftIconHalfArrowLeft {
+        background-position: -1888px 0px;
+    }
+    .rftIconHalfArrowRight {
+        background-position: -1920px 0px;
+    }
 }
Index: Dev/trunk/src/client/qed-client/css/loading.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/loading.less	(revision 529)
+++ Dev/trunk/src/client/qed-client/css/loading.less	(revision 529)
@@ -0,0 +1,23 @@
+#rft.claro {
+        
+    .qedLoading {
+        background-image: url('images/loading-lightgrey-on-darkgrey.gif');
+        background-repeat: no-repeat;
+        background-color: transparent;
+        border: none;
+        width: 16px;
+        height: 11px;
+        display: inline-block;
+    }
+
+    .dijitTabContainerLeft-tabs .dijitTab.dijitTabHover .qedLoading {
+        background-image: url('images/loading-white-on-darkgrey.gif');
+    }
+
+    .blue {
+        .dijitTabContainerLeft-tabs .dijitTab.dijitTabChecked .qedLoading {
+            background-image: url('images/loading-white-on-blue.gif');
+        }
+    }
+
+}
Index: Dev/trunk/src/client/qed-client/css/mixins.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/mixins.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/mixins.less	(revision 529)
@@ -67,4 +67,7 @@
 	.setIconSize(@size, "");
 }
+.setIcon (@size, grey) {
+	.setIconSize(@size, "g");
+}
 .setIcon (@size) {
 	.setIconSize(@size, "");
Index: Dev/trunk/src/client/qed-client/css/qed.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/qed.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/qed.less	(revision 529)
@@ -15,4 +15,5 @@
 @import "fonts.less";
 @import "icons.less";
+@import "loading.less";
 @import "layout.less";
 @import "forms.less";
Index: Dev/trunk/src/client/qed-client/css/variables.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/variables.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/variables.less	(revision 529)
@@ -6,4 +6,5 @@
 @headers: #999999;
 @text: #ffffff;
+@inactivetext: #aaaaaa;
 @disabledtext: #777777;
 
Index: Dev/trunk/src/client/qed-client/css/widgets/BlockButton.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/widgets/BlockButton.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/widgets/BlockButton.less	(revision 529)
@@ -5,8 +5,12 @@
     height: @button_block_height;
     vertical-align: top;
-    color: @text;
+    color: @inactivetext;
 
     &.dijitDisabled {
         color: @disabledtext;
+    }
+
+    &.dijitHover {
+        color: @text;
     }
 
@@ -30,5 +34,5 @@
 
         .rftIcon {
-            .setIcon(16px);
+            .setIcon(16px, grey);
         }
     }
@@ -39,5 +43,5 @@
         .rftIcon {
             vertical-align: top;
-            .setIcon(16px, black);
+            .setIcon(16px, white);
         }
     }
Index: Dev/trunk/src/client/qed-client/css/widgets/LargeButton.less
===================================================================
--- Dev/trunk/src/client/qed-client/css/widgets/LargeButton.less	(revision 525)
+++ Dev/trunk/src/client/qed-client/css/widgets/LargeButton.less	(revision 529)
@@ -7,5 +7,5 @@
         height: @button_large_height;
         padding: 3px;
-        color: @text;
+        color: @inactivetext;
 
         &*, * {
@@ -20,4 +20,8 @@
         }
 
+        &.dijitHover {
+            color: @text;
+        }
+
         .dijitButtonNode {
 
@@ -30,5 +34,5 @@
 
             .rftIcon {
-                .setIcon(24px);
+                .setIcon(24px, grey);
             }
 
@@ -45,7 +49,11 @@
         }
 
-        &.rftLargeButtonHover .dijitButtonNode,
-        &.rftLargeButtonActive .dijitButtonNode {
+        &.rftLargeButtonHover,
+        &.rftLargeButtonActive {
             .transition (0.1s);
+            .rftIcon {
+                vertical-align: top;
+                .setIcon(24px, white);
+            }
         }
     }
Index: Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorToolkit.js
===================================================================
--- Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorToolkit.js	(revision 525)
+++ Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorToolkit.js	(revision 529)
@@ -111,4 +111,7 @@
         },
         _onCategoryAdd: function() {
+            // it seems, the button is not disabled properly and still
+            // generates click events, that's why we chack here.
+            if ( this.disabled || this.readOnly ) { return; }
             this._categoryList.appendItem(this._categorySelect.get('displayedValue')); 
             this._categorySelect.reset();
Index: Dev/trunk/src/client/qed-client/model/widgets/templates/QuestionEditorToolkit.html
===================================================================
--- Dev/trunk/src/client/qed-client/model/widgets/templates/QuestionEditorToolkit.html	(revision 525)
+++ Dev/trunk/src/client/qed-client/model/widgets/templates/QuestionEditorToolkit.html	(revision 529)
@@ -1,23 +1,40 @@
 <form>
 	<div data-dojo-type="../../widgets/TitleGroup">
-		<div data-dojo-type="dijit/TitlePane" class="orange" data-dojo-props="open:true" title="Properties" data-dojo-props="iconClass:'rftIcon rftIconProperties'">
+		<div data-dojo-type="dijit/TitlePane"
+             class="orange"
+             data-dojo-props="open:true"
+             title="Properties"
+             data-dojo-props="iconClass:'rftIcon rftIconProperties'">
             <fieldset class="align">
-                <label>Title:</label><input data-dojo-type="dijit/form/ValidationTextBox" required="required" name="title"/>
-                <label>Code:</label><input data-dojo-type="dijit/form/ValidationTextBox" required="required" name="code"/>
+                <label>Title:</label><input data-dojo-type="dijit/form/ValidationTextBox"
+                                            required="required" name="title"/>
+                <label>Code:</label><input data-dojo-type="dijit/form/ValidationTextBox"
+                                           required="required" name="code"/>
                 <label>Categories:</label>
-                <div data-dojo-attach-point="categoryListNode" class="rftLineListView"></div>
+                <div data-dojo-attach-point="categoryListNode"
+                     class="rftLineListView"></div>
                 <div data-dojo-attach-point="categoryBoxNode"></div>
-                <button class="inheritBgColor" data-dojo-type="dijit/form/Button" data-dojo-attach-event="onClick:_onCategoryAdd" data-dojo-props="baseClass:'rftBlockButton', iconClass: 'rftIcon rftIconPlus'">Add</button><br/>
+                <button class="inheritBgColor"
+                        data-dojo-type="dijit/form/Button"
+                        data-dojo-attach-event="onClick:_onCategoryAdd"
+                        data-dojo-props="baseClass:'rftBlockButton', iconClass: 'rftIcon rftIconPlus'">
+                  Add</button><br/>
                 <label>Topic:</label>
                 <div data-dojo-attach-point="topicBoxNode"></div>
-                <label>Description:</label><textarea data-dojo-type="dijit/form/Textarea" name="description"></textarea>
+                <label>Description:</label>
+                <textarea data-dojo-type="dijit/form/Textarea"
+                          name="description"></textarea>
             </fieldset>
 		</div>
 
-		<div data-dojo-type="dijit/TitlePane" title="Content" data-dojo-props="iconClass:'rftIcon rftIconPlus', open:false">
+		<div data-dojo-type="dijit/TitlePane"
+             title="Content"
+             data-dojo-props="iconClass:'rftIcon rftIconPlus', open:false">
 			<div data-dojo-attach-point="ToolkitContentSourceNode"></div>
 		</div>
 
-		<div data-dojo-type="dijit/TitlePane" title="Inputs" data-dojo-props="iconClass:'rftIcon rftIconInput', open:false">
+		<div data-dojo-type="dijit/TitlePane"
+             title="Inputs"
+             data-dojo-props="iconClass:'rftIcon rftIconInput', open:false">
 			<div data-dojo-attach-point="ToolkitInputsSourceNode"></div>
 		</div>
Index: Dev/trunk/src/client/qed-client/pages/questions.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/questions.js	(revision 525)
+++ Dev/trunk/src/client/qed-client/pages/questions.js	(revision 529)
@@ -50,4 +50,7 @@
         },
         onDeleteQuestion: function(question) {
+            if ( !confirm("Are you sure you want to delete this question?") ) {
+                return;
+            }
             questions.remove(question)
             .then(lang.hitch(this,function(){
@@ -62,4 +65,7 @@
         },
         onPublishQuestion: function(question) {
+            if ( !confirm("After publication the question cannot be modified anymore, are you sure?") ) {
+                return;
+            }
             question.publicationDate = new Date();
             questions.save(question)
Index: Dev/trunk/src/client/qed-client/pages/surveyRun.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/surveyRun.js	(revision 525)
+++ Dev/trunk/src/client/qed-client/pages/surveyRun.js	(revision 529)
@@ -47,13 +47,16 @@
             .then(lang.hitch(this,function(allResponses){
                 array.forEach(allResponses, function(response){
-                    var actions = {};
+                    var actions = {}, w;
                     if ( !response.publicationDate ) {
                         actions.Delete = {
-                            callback: function(){
-                                responses.remove(response)
-                                .then(function(){
-                                    w.destroy();
-                                });
-                            },
+                            callback: lang.hitch(this,function(){
+                                // We cannot bind _onDeleteResponse
+                                // directly, because of the
+                                // initialization problem with w. We
+                                // need it in the handler, but we need
+                                // to pass the handler as an argument
+                                // on the creation of w.
+                                this._onDeleteResponse(response,w);
+                            }),
                             properties: {
                                 icon: 'Delete',
@@ -62,5 +65,5 @@
                         };
                     }
-                    var w = new LineWithActionsWidget({
+                    w = new LineWithActionsWidget({
                         actions: actions
                     });
@@ -70,4 +73,13 @@
                 }, this);
             }));
+        },
+        _onDeleteResponse: function(response,w) {
+            if ( !confirm("Are you sure you want to delete this survey response?") ) {
+                return;
+            }
+            responses.remove(response)
+            .then(function(){
+                w.destroy();
+            });
         },
         _handlePropChange: function(e) {
Index: Dev/trunk/src/client/qed-client/pages/surveys.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/surveys.js	(revision 525)
+++ Dev/trunk/src/client/qed-client/pages/surveys.js	(revision 529)
@@ -16,4 +16,7 @@
             if ( this._started ) { return; }
             this.inherited(arguments);
+            this.draftsTab.set('title','Drafts (<span class="qedLoading"></span>)');
+            this.publishedTab.set('title','Published (<span class="qedLoading"></span>)');
+            this.runsTab.set('title','Runs (<span class="qedLoading"></span>)');
             this.refresh();
         },
@@ -22,20 +25,24 @@
         },
         _onPublishSurvey:function(survey){
-            var self = this;
+            if ( !confirm("After publication the survey cannot be modified anymore, are you sure?") ) {
+                return;
+            }
             survey.publicationDate = new Date();
             surveys.save(survey)
-            .then(function(){
-                self.refreshDrafts();
-                self.refreshPublished();
-            },lang.hitch(this,function(err){
+            .then(lang.hitch(this,function(){
+                this.refreshDrafts();
+                this.refreshPublished();
+            }),lang.hitch(this,function(err){
                 this.notify(err.error,'error');
             }));
         },
         _onDeleteSurvey:function(survey){
-            var self = this;
+            if ( !confirm("Are you sure you want to delete this draft survey?") ) {
+                return;
+            }
             surveys.remove(survey)
-            .then(function(){
-                self.refreshDrafts();
-            },lang.hitch(this,function(err){
+            .then(lang.hitch(this,function(){
+                this.refreshDrafts();
+            }),lang.hitch(this,function(err){
                 this.notify(err.error,'error');
             }));
@@ -62,4 +69,7 @@
         },
         _onRunDelete: function(surveyRun) {
+            if ( !confirm("Are you sure you want to delete this survey run?") ) {
+                return;
+            }
             surveyRuns.remove(surveyRun)
             .then(lang.hitch(this,function(){
@@ -135,5 +145,5 @@
                                 label: 'Run',
                                 tooltip: 'Run survey',
-                                icon: 'Run'
+                                icon: 'Forward'
                             }
                         }]
Index: Dev/trunk/src/client/qed-client/pages/templates/surveys.html
===================================================================
--- Dev/trunk/src/client/qed-client/pages/templates/surveys.html	(revision 525)
+++ Dev/trunk/src/client/qed-client/pages/templates/surveys.html	(revision 529)
@@ -8,7 +8,11 @@
     </div>
 
-    <div data-dojo-attach-point="tabContainer" data-dojo-type="dijit/layout/TabContainer" class="blue" data-dojo-props="tabPosition:'left-h',region:'center'">
+    <div data-dojo-attach-point="tabContainer"
+         data-dojo-type="dijit/layout/TabContainer"
+         class="blue" data-dojo-props="tabPosition:'left-h',region:'center'">
 
-        <div data-dojo-type="dijit/layout/BorderContainer" title="Drafts" data-dojo-attach-point="draftsTab">
+        <div data-dojo-type="dijit/layout/BorderContainer"
+             title="Drafts"
+             data-dojo-attach-point="draftsTab">
             <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'center'" data-dojo-attach-point="draftsContainer">
             </div>
@@ -17,21 +21,38 @@
         </div>
 
-        <div data-dojo-type="dijit/layout/BorderContainer" title="Published" data-dojo-attach-point="publishedTab">
-            <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'center'" data-dojo-attach-point="publishedContainer">
+        <div data-dojo-type="dijit/layout/BorderContainer"
+             title="Published"
+             data-dojo-attach-point="publishedTab">
+            <div data-dojo-type="dijit/layout/ContentPane"
+                 data-dojo-props="region: 'center'"
+                 data-dojo-attach-point="publishedContainer">
             </div>
-            <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'bottom'" style="height: 40px;">
+            <div data-dojo-type="dijit/layout/ContentPane"
+                 data-dojo-props="region: 'bottom'"
+                 style="height: 40px;">
             </div>
         </div>
 
-        <div data-dojo-type="dijit/layout/BorderContainer" title="Runs" data-dojo-attach-point="runsTab">
-            <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'center'" data-dojo-attach-point="runsContainer">
+        <div data-dojo-type="dijit/layout/BorderContainer"
+             title="Runs"
+             data-dojo-attach-point="runsTab">
+            <div data-dojo-type="dijit/layout/ContentPane"
+                 data-dojo-props="region: 'center'"
+                 data-dojo-attach-point="runsContainer">
             </div>
-            <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'bottom'" style="height: 40px;">
+            <div data-dojo-type="dijit/layout/ContentPane"
+                 data-dojo-props="region: 'bottom'"
+                 style="height: 40px;">
             </div>
         </div>
     </div>
 
-    <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region: 'bottom'" style="height: 40px;">
-        <button data-dojo-type="dijit/form/Button" class="blue" data-dojo-props="baseClass: 'rftBlockButton', iconClass: 'rftIcon rftIconNew'" data-dojo-attach-event="onClick:_onNewSurvey">New survey</button>
+    <div data-dojo-type="dijit/layout/ContentPane"
+         data-dojo-props="region: 'bottom'"
+         style="height: 40px;">
+        <button data-dojo-type="dijit/form/Button"
+                class="blue"
+                data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconNew'"
+                data-dojo-attach-event="onClick:_onNewSurvey">New survey</button>
     </div>
 